Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Prediction.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Prediction.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Prediction.cs	(revision 4068)
@@ -19,170 +19,149 @@
 
 using System;
+using System.Diagnostics;
 using System.IO;
-using System.Diagnostics;
 
-namespace SVM
-{
+namespace SVM {
+  /// <summary>
+  /// Class containing the routines to perform class membership prediction using a trained SVM.
+  /// </summary>
+  public static class Prediction {
     /// <summary>
-    /// Class containing the routines to perform class membership prediction using a trained SVM.
+    /// Predicts the class memberships of all the vectors in the problem.
     /// </summary>
-    public static class Prediction
-    {
-        /// <summary>
-        /// Predicts the class memberships of all the vectors in the problem.
-        /// </summary>
-        /// <param name="problem">The SVM Problem to solve</param>
-        /// <param name="outputFile">File for result output</param>
-        /// <param name="model">The Model to use</param>
-        /// <param name="predict_probability">Whether to output a distribution over the classes</param>
-        /// <returns>Percentage correctly labelled</returns>
-        public static double Predict(
-            Problem problem,
-            string outputFile,
-            Model model,
-            bool predict_probability)
-        {
-            int correct = 0;
-            int total = 0;
-            double error = 0;
-            double sumv = 0, sumy = 0, sumvv = 0, sumyy = 0, sumvy = 0;
-            StreamWriter output = outputFile != null ? new StreamWriter(outputFile) : null;
+    /// <param name="problem">The SVM Problem to solve</param>
+    /// <param name="outputFile">File for result output</param>
+    /// <param name="model">The Model to use</param>
+    /// <param name="predict_probability">Whether to output a distribution over the classes</param>
+    /// <returns>Percentage correctly labelled</returns>
+    public static double Predict(
+        Problem problem,
+        string outputFile,
+        Model model,
+        bool predict_probability) {
+      int correct = 0;
+      int total = 0;
+      double error = 0;
+      double sumv = 0, sumy = 0, sumvv = 0, sumyy = 0, sumvy = 0;
+      StreamWriter output = outputFile != null ? new StreamWriter(outputFile) : null;
 
-            SvmType svm_type = Procedures.svm_get_svm_type(model);
-            int nr_class = Procedures.svm_get_nr_class(model);
-            int[] labels = new int[nr_class];
-            double[] prob_estimates = null;
+      SvmType svm_type = Procedures.svm_get_svm_type(model);
+      int nr_class = Procedures.svm_get_nr_class(model);
+      int[] labels = new int[nr_class];
+      double[] prob_estimates = null;
 
-            if (predict_probability)
-            {
-                if (svm_type == SvmType.EPSILON_SVR || svm_type == SvmType.NU_SVR)
-                {
-                    Console.WriteLine("Prob. model for test data: target value = predicted value + z,\nz: Laplace distribution e^(-|z|/sigma)/(2sigma),sigma=" + Procedures.svm_get_svr_probability(model));
-                }
-                else
-                {
-                    Procedures.svm_get_labels(model, labels);
-                    prob_estimates = new double[nr_class];
-                    if (output != null)
-                    {
-                        output.Write("labels");
-                        for (int j = 0; j < nr_class; j++)
-                        {
-                            output.Write(" " + labels[j]);
-                        }
-                        output.Write("\n");
-                    }
-                }
+      if (predict_probability) {
+        if (svm_type == SvmType.EPSILON_SVR || svm_type == SvmType.NU_SVR) {
+          Console.WriteLine("Prob. model for test data: target value = predicted value + z,\nz: Laplace distribution e^(-|z|/sigma)/(2sigma),sigma=" + Procedures.svm_get_svr_probability(model));
+        } else {
+          Procedures.svm_get_labels(model, labels);
+          prob_estimates = new double[nr_class];
+          if (output != null) {
+            output.Write("labels");
+            for (int j = 0; j < nr_class; j++) {
+              output.Write(" " + labels[j]);
             }
-            for (int i = 0; i < problem.Count; i++)
-            {
-                double target = problem.Y[i];
-                Node[] x = problem.X[i];
+            output.Write("\n");
+          }
+        }
+      }
+      for (int i = 0; i < problem.Count; i++) {
+        double target = problem.Y[i];
+        Node[] x = problem.X[i];
 
-                double v;
-                if (predict_probability && (svm_type == SvmType.C_SVC || svm_type == SvmType.NU_SVC))
-                {
-                    v = Procedures.svm_predict_probability(model, x, prob_estimates);
-                    if (output != null)
-                    {
-                        output.Write(v + " ");
-                        for (int j = 0; j < nr_class; j++)
-                        {
-                            output.Write(prob_estimates[j] + " ");
-                        }
-                        output.Write("\n");
-                    }
-                }
-                else
-                {
-                    v = Procedures.svm_predict(model, x);
-                    if(output != null)
-                        output.Write(v + "\n");
-                }
-
-                if (v == target)
-                    ++correct;
-                error += (v - target) * (v - target);
-                sumv += v;
-                sumy += target;
-                sumvv += v * v;
-                sumyy += target * target;
-                sumvy += v * target;
-                ++total;
+        double v;
+        if (predict_probability && (svm_type == SvmType.C_SVC || svm_type == SvmType.NU_SVC)) {
+          v = Procedures.svm_predict_probability(model, x, prob_estimates);
+          if (output != null) {
+            output.Write(v + " ");
+            for (int j = 0; j < nr_class; j++) {
+              output.Write(prob_estimates[j] + " ");
             }
-            if(output != null)
-                output.Close();
-            return (double)correct / total;
+            output.Write("\n");
+          }
+        } else {
+          v = Procedures.svm_predict(model, x);
+          if (output != null)
+            output.Write(v + "\n");
         }
 
-        /// <summary>
-        /// Predict the class for a single input vector.
-        /// </summary>
-        /// <param name="model">The Model to use for prediction</param>
-        /// <param name="x">The vector for which to predict class</param>
-        /// <returns>The result</returns>
-        public static double Predict(Model model, Node[] x)
-        {
-            return Procedures.svm_predict(model, x);
+        if (v == target)
+          ++correct;
+        error += (v - target) * (v - target);
+        sumv += v;
+        sumy += target;
+        sumvv += v * v;
+        sumyy += target * target;
+        sumvy += v * target;
+        ++total;
+      }
+      if (output != null)
+        output.Close();
+      return (double)correct / total;
+    }
+
+    /// <summary>
+    /// Predict the class for a single input vector.
+    /// </summary>
+    /// <param name="model">The Model to use for prediction</param>
+    /// <param name="x">The vector for which to predict class</param>
+    /// <returns>The result</returns>
+    public static double Predict(Model model, Node[] x) {
+      return Procedures.svm_predict(model, x);
+    }
+
+    /// <summary>
+    /// Predicts a class distribution for the single input vector.
+    /// </summary>
+    /// <param name="model">Model to use for prediction</param>
+    /// <param name="x">The vector for which to predict the class distribution</param>
+    /// <returns>A probability distribtion over classes</returns>
+    public static double[] PredictProbability(Model model, Node[] x) {
+      SvmType svm_type = Procedures.svm_get_svm_type(model);
+      if (svm_type != SvmType.C_SVC && svm_type != SvmType.NU_SVC)
+        throw new Exception("Model type " + svm_type + " unable to predict probabilities.");
+      int nr_class = Procedures.svm_get_nr_class(model);
+      double[] probEstimates = new double[nr_class];
+      Procedures.svm_predict_probability(model, x, probEstimates);
+      return probEstimates;
+    }
+
+    private static void exit_with_help() {
+      Debug.Write("usage: svm_predict [options] test_file model_file output_file\n" + "options:\n" + "-b probability_estimates: whether to predict probability estimates, 0 or 1 (default 0); one-class SVM not supported yet\n");
+      Environment.Exit(1);
+    }
+
+    /// <summary>
+    /// Legacy method, provided to allow usage as though this were the command line version of libsvm.
+    /// </summary>
+    /// <param name="args">Standard arguments passed to the svm_predict exectutable.  See libsvm documentation for details.</param>
+    [Obsolete("Use the other version of Predict() instead")]
+    public static void Predict(params string[] args) {
+      int i = 0;
+      bool predictProbability = false;
+
+      // parse options
+      for (i = 0; i < args.Length; i++) {
+        if (args[i][0] != '-')
+          break;
+        ++i;
+        switch (args[i - 1][1]) {
+
+          case 'b':
+            predictProbability = int.Parse(args[i]) == 1;
+            break;
+
+          default:
+            throw new ArgumentException("Unknown option");
+
         }
+      }
+      if (i >= args.Length)
+        throw new ArgumentException("No input, model and output files provided");
 
-        /// <summary>
-        /// Predicts a class distribution for the single input vector.
-        /// </summary>
-        /// <param name="model">Model to use for prediction</param>
-        /// <param name="x">The vector for which to predict the class distribution</param>
-        /// <returns>A probability distribtion over classes</returns>
-        public static double[] PredictProbability(Model model, Node[] x)
-        {
-            SvmType svm_type = Procedures.svm_get_svm_type(model);
-            if (svm_type != SvmType.C_SVC && svm_type != SvmType.NU_SVC)
-                throw new Exception("Model type " + svm_type + " unable to predict probabilities.");
-            int nr_class = Procedures.svm_get_nr_class(model);
-            double[] probEstimates = new double[nr_class];
-            Procedures.svm_predict_probability(model, x, probEstimates);
-            return probEstimates;
-        }
-
-        private static void exit_with_help()
-        {
-            Debug.Write("usage: svm_predict [options] test_file model_file output_file\n" + "options:\n" + "-b probability_estimates: whether to predict probability estimates, 0 or 1 (default 0); one-class SVM not supported yet\n");
-            Environment.Exit(1);
-        }
-
-        /// <summary>
-        /// Legacy method, provided to allow usage as though this were the command line version of libsvm.
-        /// </summary>
-        /// <param name="args">Standard arguments passed to the svm_predict exectutable.  See libsvm documentation for details.</param>
-        [Obsolete("Use the other version of Predict() instead")]
-        public static void Predict(params string[] args)
-        {
-            int i = 0;
-            bool predictProbability = false;
-
-            // parse options
-            for (i = 0; i < args.Length; i++)
-            {
-                if (args[i][0] != '-')
-                    break;
-                ++i;
-                switch (args[i - 1][1])
-                {
-
-                    case 'b':
-                        predictProbability = int.Parse(args[i]) == 1;
-                        break;
-
-                    default:
-                        throw new ArgumentException("Unknown option");
-
-                }
-            }
-            if (i >= args.Length)
-                throw new ArgumentException("No input, model and output files provided");
-
-            Problem problem = Problem.Read(args[i]);
-            Model model = Model.Read(args[i + 1]);
-            Predict(problem, args[i + 2], model, predictProbability);
-        }
+      Problem problem = Problem.Read(args[i]);
+      Model model = Model.Read(args[i + 1]);
+      Predict(problem, args[i + 2], model, predictProbability);
     }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Problem.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Problem.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Problem.cs	(revision 4068)
@@ -19,194 +19,165 @@
 
 using System;
+using System.Collections.Generic;
 using System.IO;
-using System.Collections.Generic;
-using System.Threading;
-using System.Globalization;
 
-namespace SVM
-{
+namespace SVM {
+  /// <summary>
+  /// Encapsulates a problem, or set of vectors which must be classified.
+  /// </summary>
+  [Serializable]
+  public class Problem {
+    private int _count;
+    private double[] _Y;
+    private Node[][] _X;
+    private int _maxIndex;
+
     /// <summary>
-    /// Encapsulates a problem, or set of vectors which must be classified.
+    /// Constructor.
     /// </summary>
-	[Serializable]
-	public class Problem
-	{
-        private int _count;
-        private double[] _Y;
-        private Node[][] _X;
-        private int _maxIndex;
+    /// <param name="count">Number of vectors</param>
+    /// <param name="y">The class labels</param>
+    /// <param name="x">Vector data.</param>
+    /// <param name="maxIndex">Maximum index for a vector</param>
+    public Problem(int count, double[] y, Node[][] x, int maxIndex) {
+      _count = count;
+      _Y = y;
+      _X = x;
+      _maxIndex = maxIndex;
+    }
+    /// <summary>
+    /// Empty Constructor.  Nothing is initialized.
+    /// </summary>
+    public Problem() {
+    }
+    /// <summary>
+    /// Number of vectors.
+    /// </summary>
+    public int Count {
+      get {
+        return _count;
+      }
+      set {
+        _count = value;
+      }
+    }
+    /// <summary>
+    /// Class labels.
+    /// </summary>
+    public double[] Y {
+      get {
+        return _Y;
+      }
+      set {
+        _Y = value;
+      }
+    }
+    /// <summary>
+    /// Vector data.
+    /// </summary>
+    public Node[][] X {
+      get {
+        return _X;
+      }
+      set {
+        _X = value;
+      }
+    }
+    /// <summary>
+    /// Maximum index for a vector.
+    /// </summary>
+    public int MaxIndex {
+      get {
+        return _maxIndex;
+      }
+      set {
+        _maxIndex = value;
+      }
+    }
 
-        /// <summary>
-        /// Constructor.
-        /// </summary>
-        /// <param name="count">Number of vectors</param>
-        /// <param name="y">The class labels</param>
-        /// <param name="x">Vector data.</param>
-        /// <param name="maxIndex">Maximum index for a vector</param>
-        public Problem(int count, double[] y, Node[][] x, int maxIndex)
-        {
-            _count = count;
-            _Y = y;
-            _X = x;
-            _maxIndex = maxIndex;
+    /// <summary>
+    /// Reads a problem from a stream.
+    /// </summary>
+    /// <param name="stream">Stream to read from</param>
+    /// <returns>The problem</returns>
+    public static Problem Read(Stream stream) {
+      TemporaryCulture.Start();
+
+      StreamReader input = new StreamReader(stream);
+      List<double> vy = new List<double>();
+      List<Node[]> vx = new List<Node[]>();
+      int max_index = 0;
+
+      while (input.Peek() > -1) {
+        string[] parts = input.ReadLine().Trim().Split();
+
+        vy.Add(double.Parse(parts[0]));
+        int m = parts.Length - 1;
+        Node[] x = new Node[m];
+        for (int j = 0; j < m; j++) {
+          x[j] = new Node();
+          string[] nodeParts = parts[j + 1].Split(':');
+          x[j].Index = int.Parse(nodeParts[0]);
+          x[j].Value = double.Parse(nodeParts[1]);
         }
-        /// <summary>
-        /// Empty Constructor.  Nothing is initialized.
-        /// </summary>
-        public Problem()
-        {
-        }
-        /// <summary>
-        /// Number of vectors.
-        /// </summary>
-        public int Count
-        {
-            get
-            {
-                return _count;
-            }
-            set
-            {
-                _count = value;
-            }
-        }
-        /// <summary>
-        /// Class labels.
-        /// </summary>
-        public double[] Y
-        {
-            get
-            {
-                return _Y;
-            }
-            set
-            {
-                _Y = value;
-            }
-        }
-        /// <summary>
-        /// Vector data.
-        /// </summary>
-        public Node[][] X
-        {
-            get
-            {
-                return _X;
-            }
-            set
-            {
-                _X = value;
-            }
-        }
-        /// <summary>
-        /// Maximum index for a vector.
-        /// </summary>
-        public int MaxIndex
-        {
-            get
-            {
-                return _maxIndex;
-            }
-            set
-            {
-                _maxIndex = value;
-            }
-        }
+        if (m > 0)
+          max_index = Math.Max(max_index, x[m - 1].Index);
+        vx.Add(x);
+      }
 
-        /// <summary>
-        /// Reads a problem from a stream.
-        /// </summary>
-        /// <param name="stream">Stream to read from</param>
-        /// <returns>The problem</returns>
-        public static Problem Read(Stream stream)
-        {
-            TemporaryCulture.Start();
+      TemporaryCulture.Stop();
 
-            StreamReader input = new StreamReader(stream);
-            List<double> vy = new List<double>();
-            List<Node[]> vx = new List<Node[]>();
-            int max_index = 0;
+      return new Problem(vy.Count, vy.ToArray(), vx.ToArray(), max_index);
+    }
 
-            while (input.Peek() > -1)
-            {
-                string[] parts = input.ReadLine().Trim().Split();
+    /// <summary>
+    /// Writes a problem to a stream.
+    /// </summary>
+    /// <param name="stream">The stream to write the problem to.</param>
+    /// <param name="problem">The problem to write.</param>
+    public static void Write(Stream stream, Problem problem) {
+      TemporaryCulture.Start();
 
-                vy.Add(double.Parse(parts[0]));
-                int m = parts.Length - 1;
-                Node[] x = new Node[m];
-                for (int j = 0; j < m; j++)
-                {
-                    x[j] = new Node();
-                    string[] nodeParts = parts[j + 1].Split(':');
-                    x[j].Index = int.Parse(nodeParts[0]);
-                    x[j].Value = double.Parse(nodeParts[1]);
-                }
-                if (m > 0)
-                    max_index = Math.Max(max_index, x[m - 1].Index);
-                vx.Add(x);
-            }
+      StreamWriter output = new StreamWriter(stream);
+      for (int i = 0; i < problem.Count; i++) {
+        output.Write(problem.Y[i]);
+        for (int j = 0; j < problem.X[i].Length; j++)
+          output.Write(" {0}:{1}", problem.X[i][j].Index, problem.X[i][j].Value);
+        output.WriteLine();
+      }
+      output.Flush();
 
-            TemporaryCulture.Stop();
+      TemporaryCulture.Stop();
+    }
 
-            return new Problem(vy.Count, vy.ToArray(), vx.ToArray(), max_index);
-        }
+    /// <summary>
+    /// Reads a Problem from a file.
+    /// </summary>
+    /// <param name="filename">The file to read from.</param>
+    /// <returns>the Probem</returns>
+    public static Problem Read(string filename) {
+      FileStream input = File.OpenRead(filename);
+      try {
+        return Read(input);
+      }
+      finally {
+        input.Close();
+      }
+    }
 
-        /// <summary>
-        /// Writes a problem to a stream.
-        /// </summary>
-        /// <param name="stream">The stream to write the problem to.</param>
-        /// <param name="problem">The problem to write.</param>
-        public static void Write(Stream stream, Problem problem)
-        {
-            TemporaryCulture.Start();
-
-            StreamWriter output = new StreamWriter(stream);
-            for (int i = 0; i < problem.Count; i++)
-            {
-                output.Write(problem.Y[i]);
-                for (int j = 0; j < problem.X[i].Length; j++)
-                    output.Write(" {0}:{1}", problem.X[i][j].Index, problem.X[i][j].Value);
-                output.WriteLine();
-            }
-            output.Flush();
-
-            TemporaryCulture.Stop();
-        }
-
-        /// <summary>
-        /// Reads a Problem from a file.
-        /// </summary>
-        /// <param name="filename">The file to read from.</param>
-        /// <returns>the Probem</returns>
-        public static Problem Read(string filename)
-        {
-            FileStream input = File.OpenRead(filename);
-            try
-            {
-                return Read(input);
-            }
-            finally
-            {
-                input.Close();
-            }
-        }
-
-        /// <summary>
-        /// Writes a problem to a file.   This will overwrite any previous data in the file.
-        /// </summary>
-        /// <param name="filename">The file to write to</param>
-        /// <param name="problem">The problem to write</param>
-        public static void Write(string filename, Problem problem)
-        {
-            FileStream output = File.Open(filename, FileMode.Create);
-            try
-            {
-                Write(output, problem);
-            }
-            finally
-            {
-                output.Close();
-            }
-        }
+    /// <summary>
+    /// Writes a problem to a file.   This will overwrite any previous data in the file.
+    /// </summary>
+    /// <param name="filename">The file to write to</param>
+    /// <param name="problem">The problem to write</param>
+    public static void Write(string filename, Problem problem) {
+      FileStream output = File.Open(filename, FileMode.Create);
+      try {
+        Write(output, problem);
+      }
+      finally {
+        output.Close();
+      }
     }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Properties/AssemblyInfo.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Properties/AssemblyInfo.cs	(revision 4068)
@@ -1,4 +1,3 @@
 ﻿using System.Reflection;
-using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
 
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/RangeTransform.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/RangeTransform.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/RangeTransform.cs	(revision 4068)
@@ -20,6 +20,4 @@
 using System;
 using System.IO;
-using System.Threading;
-using System.Globalization;
 
 namespace SVM {
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/SVMExtensions.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/SVMExtensions.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/SVMExtensions.cs	(revision 4068)
@@ -1,17 +1,10 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-
-namespace SVM
-{
-    internal static class SVMExtensions
-    {
-        public static void SwapIndex<T>(this T[] list, int i, int j)
-        {
-            T tmp = list[i];
-            list[i] = list[j];
-            list[j] = tmp;
-        }
+﻿
+namespace SVM {
+  internal static class SVMExtensions {
+    public static void SwapIndex<T>(this T[] list, int i, int j) {
+      T tmp = list[i];
+      list[i] = list[j];
+      list[j] = tmp;
     }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Scaling.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Scaling.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Scaling.cs	(revision 4068)
@@ -18,32 +18,27 @@
 
 
-using System;
 
-namespace SVM
-{
+namespace SVM {
+  /// <summary>
+  /// Deals with the scaling of Problems so they have uniform ranges across all dimensions in order to
+  /// result in better SVM performance.
+  /// </summary>
+  public static class Scaling {
     /// <summary>
-    /// Deals with the scaling of Problems so they have uniform ranges across all dimensions in order to
-    /// result in better SVM performance.
+    /// Scales a problem using the provided range.  This will not affect the parameter.
     /// </summary>
-    public static class Scaling
-    {
-        /// <summary>
-        /// Scales a problem using the provided range.  This will not affect the parameter.
-        /// </summary>
-        /// <param name="prob">The problem to scale</param>
-        /// <param name="range">The Range transform to use in scaling</param>
-        /// <returns>The Scaled problem</returns>
-        public static Problem Scale(this IRangeTransform range, Problem prob)
-        {
-            Problem scaledProblem = new Problem(prob.Count, new double[prob.Count], new Node[prob.Count][], prob.MaxIndex);
-            for (int i = 0; i < scaledProblem.Count; i++)
-            {
-                scaledProblem.X[i] = new Node[prob.X[i].Length];
-                for (int j = 0; j < scaledProblem.X[i].Length; j++)
-                    scaledProblem.X[i][j] = new Node(prob.X[i][j].Index, range.Transform(prob.X[i][j].Value, prob.X[i][j].Index));
-                scaledProblem.Y[i] = prob.Y[i];
-            }
-            return scaledProblem;
-        }
+    /// <param name="prob">The problem to scale</param>
+    /// <param name="range">The Range transform to use in scaling</param>
+    /// <returns>The Scaled problem</returns>
+    public static Problem Scale(this IRangeTransform range, Problem prob) {
+      Problem scaledProblem = new Problem(prob.Count, new double[prob.Count], new Node[prob.Count][], prob.MaxIndex);
+      for (int i = 0; i < scaledProblem.Count; i++) {
+        scaledProblem.X[i] = new Node[prob.X[i].Length];
+        for (int j = 0; j < scaledProblem.X[i].Length; j++)
+          scaledProblem.X[i][j] = new Node(prob.X[i][j].Index, range.Transform(prob.X[i][j].Value, prob.X[i][j].Index));
+        scaledProblem.Y[i] = prob.Y[i];
+      }
+      return scaledProblem;
     }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/TemporaryCulture.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/TemporaryCulture.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/TemporaryCulture.cs	(revision 4068)
@@ -1,25 +1,17 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Globalization;
+﻿using System.Globalization;
 using System.Threading;
 
-namespace SVM
-{
-    internal static class TemporaryCulture
-    {
-        private static CultureInfo _culture;
+namespace SVM {
+  internal static class TemporaryCulture {
+    private static CultureInfo _culture;
 
-        public static void Start()
-        {
-            _culture = Thread.CurrentThread.CurrentCulture;
-            Thread.CurrentThread.CurrentCulture = CultureInfo.InvariantCulture;
-        }
+    public static void Start() {
+      _culture = Thread.CurrentThread.CurrentCulture;
+      Thread.CurrentThread.CurrentCulture = CultureInfo.InvariantCulture;
+    }
 
-        public static void Stop()
-        {
-            Thread.CurrentThread.CurrentCulture = _culture;
-        }
+    public static void Stop() {
+      Thread.CurrentThread.CurrentCulture = _culture;
     }
+  }
 }
